#!/usr/bin/perl

###############################################################################
# Version
# Auther: Takashi Sato.
###############################################################################
$VERSION = "Rendezvous. Ver.2.72, Nov.2, 2019";

&initDefine;

if ( $isCalled == 0 ) {

    print "Content-type: text/html\n\n";

    &main;
}

1;

###############################################################################
# Initial Definition
###############################################################################
sub initDefine {

    $PROG = $0;
    $PROG =~ s@^.*/@@;

    $DATA_DIR = "data_rendez/";
    $NAME_POINT = "point_data.txt";
    $NAME_GROUP = "group_data.txt";
    $NAME_TIME = "time_data.txt";

    $TITLENAME = "f[";
    $BACKCOLOR = "#ccccff";
    $HIGHLIGHT = "#ffcccc";
    $USENAME = 0;
    $SHOWCALC = 1;
    $SHOWDIRS = 1;
    $HLCOLOR = 0;
    $USENOTE = 0;
    $SIMPLEUI = 0;
    $NOHELP = 0;
    $HELPFILE = "";
    $REVCOL = 0;
    $LARGEFONT = 0;

    $pace_default = "6:30";
    $start_default = "0:00";

}	

###############################################################################
# main
###############################################################################
sub main {

#######################################
# WJA}`oCg̃fR[h
#######################################
    %keys = ();
    my @params = split( "&", $ENV{ "QUERY_STRING" } );
    if ( $#params < 0 ) {
	@params = @ARGV;
    }
    my $p;
    for $p ( @params ) {
	my $key, $value;
	( $key, $value ) = split( "=", $p );
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$keys{ $key } = $value;
    }


#######################################
# Main
#######################################

    $FILE_POINT = $DATA_DIR . $NAME_POINT;
    $FILE_GROUP = $DATA_DIR . $NAME_GROUP;
    $FILE_TIME = $DATA_DIR . $NAME_TIME;

    if ( $file = $keys{ "query" } ) {
#	&PrintHeaderUTF;
#	print "<pre>\n";

	if ( $file =~ /^locations/ ) {
	    &PrintLocationList;
	} else {
	    &PrintLocationFile( $DATA_DIR . $file );
	}

#	print "</pre>\n";
#	&PrintFooter;
#	exit 0;
    } else {

    if ( $keys{ "clear" } ) {
	&ClearDataFile;
    }

    &PrintHeader;

    &ReadDefinition;
    &HandleInputData;

    $show_calc = $SHOWCALC;
    if ( $keys{ "showcalc" } ) {
	$show_calc = 1;
    }

    &ReadDataFile;

    my $mode = $keys{ "mode" };
    if ( $mode eq "simple" ) {
	&PrintSimpleEntry;
    } elsif ( $mode eq "simplepoint" ) {
	&PrintSimplePointEntry;
    } elsif ( $mode eq "simpleadd" ) {
	&PrintSimpleAddEntry;
    } else {
	&CalcEstimTime;
	&PrintDataTable;

	if( $NOHELP == 0 ) {
	    if ( $HELPFILE ne "" ) {
		&PrintHelpFile;
	    } else {
		&PrintHelp;
	    }
	}
    }
    &PrintFooter;

    }
}


###############################################################################
# location file list
###############################################################################

sub PrintLocationList {
    opendir( DIR, $DATA_DIR );

    while (defined($dir = readdir(DIR))) {
	print "$dir\n"  if ( $dir =~ /\.plist$/ );
    }
    closedir(DIR);
}

sub PrintLocationFile {
    ( $file ) = @_;

    open( FD, "<" . $file );

    while ( <FD> ) {
	print $_;
    }
    close( FD );
}

###############################################################################
# clear data
###############################################################################
sub ClearDataFile {
    if ( -f $FILE_TIME ) {
	rename( $FILE_TIME, $FILE_TIME . ".bak" );
    }
    open( FH, ">" . $FILE_TIME );
    close( FH );
}

###############################################################################
# wb_[
###############################################################################
sub PrintHeader {
    print "<html>\n";
    print "<head>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=sjis\">";
    if ( $keys{ "refresh" } ) {
	print "<meta http-equiv=\"Refresh\" content=\"60\">";
    }
    print "<title>" . $TITLENAME . "</title>\n";
    print "</head>\n";
    print "<body bgcolor=\"" . $BACKCOLOR . "\">\n";
}

sub PrintHeaderUTF {
    print "<html>\n";
    print "<head>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">";
    print "<title> rendezvous plist </title>\n";
    print "</head>\n";
    print "<body bgcolor=\"" . $BACKCOLOR . "\">\n";
}

###############################################################################
# 
###############################################################################
sub PrintHelp {
    print "<hr>\n";
    print "O[ṽ`FbN|Cg̒ʉߎԂƁA<br>\n";
    print "Sōšoߏ󋵂mFł܂B<br>\n";
    print "XV{^ōŐVf[^邱Ƃł܂B<br>\n";
    print "y[XvZ̃`FbN{bNX`FbNčXVƁA<br>\n";
    print "ȍ~̃`FbN|Cg̎vZ܂B<br>\n";
    print "܂A͂Ƃ܂ł̃y[XvZ܂̂ŁA<br>\n";
    print "̃y[XɌvZp̃y[XύXł܂B<br>\n";
    print "ݒy[X͗\žvZɔf܂B<br>\n";
    if ( $HLCOLOR ) {
	print "FςƂ낪n_łB<br>\n";
    }
    print "͕@́A`FbN|CgyуO[v̘gIāA<br>\n";
    print "u15:34v(pp)̗lɓ͂OKΔf܂B<br>\n";
    print "Ōɓ͂̂LłB<br>\n";
    print "ԈႦꍇ͓͏ꏊw肵<br>\n";
    print "̓f[^OKΏ܂B<br>\n";
    print "݂̎gpA`FbNƎ͂ȗł܂B<br>\n";
    if ( $SIMPLEUI ) {
	print "`FbN|Cg̃Nɐiނƒn_ł̊ȈՓ͉ʂɍs܂B<br>\n";
	print "O[ṽNɂނƃO[v̍s̊ȈՓ͂ɍs܂B<br>\n";
	print "ǉ̃NɐiނƃO[vǉю͉ʂɐi݂܂B<br>\n";
    }
}

sub PrintHelpFile {
    print "<hr>\n";
    open( IN, "<", $DATA_DIR . $HELPFILE );
    while ( <IN> ) {
	print $_;
    }
    close( IN );

}

###############################################################################
# tb^[
###############################################################################
sub PrintFooter {

    print "</body>\n";
    print "</html>\n";
}

###############################################################################
# ̓f[^̏At@Cɏ
###############################################################################
sub HandleInputData {
    my ( $sec, $min, $hour ) = localtime( time );
    my $timenow = $hour . ":" . $min;

    my $section = $keys{ "position" };
    my $pos, $dir;
    ( $pos, $dir ) = split( "-", $section );

    my $pl = $keys{ "place" };
    if ( $pl eq "" ) {
	$pl = 1;
    }
    my $data = $keys{ "data" };
    my $data2 = $keys{ "data2" };
    my $data3 = $keys{ "data3" };
    if ( $keys{ "now" } ne "" ) {
	$data = $timenow;
    }

    if ( $pos eq "name" ) {
	if ( $dir eq "add" ) {
	    if ( $data ne "" ) {
		open( OUT, ">>" . $FILE_GROUP );
		print OUT $data . ",down\n";
		close( OUT );
	    }
	} elsif ( $dir eq "addnow" ) {
	    if ( $data ne "" ) {
		if ( open( OUT, ">>" . $FILE_GROUP ) ) {
		    print OUT $data . ",down\n";
		    close( OUT );
		    if ( open( OUT, ">>" . $FILE_TIME ) ) {
			print OUT $places[ $pl ] . "," . $data . "," . $timenow . "\n";
			if ( $data2 ne "" ) {
			    print OUT "note" . "," . $data . "," . $data2 . "\n";
			}
			if ( $data3 ne "" ) {
			    print OUT "pace" . "," . $data . "," . $data3 . "\n";
			}
			close( OUT );
		    }
		}
	    }
	} elsif ( $dir ne "" ) {
	    my $group = $groups[ $dir ];
	    $directions{ $group } = "delete";

	    open( OUT, ">" . $FILE_GROUP );
	    for ( $j = 0; $j <= $#groups; $j++ ) {
		my $grp = $groups[ $j ];
		my $dirgrp = $directions{ $grp };
		if ( $dirgrp ne "delete" ) {
		    print OUT $grp . "," . $dirgrp . "\n";
		}
	    }
	    close( OUT );
	}
	# re-read definition;
	&ReadDefinition;

    } elsif ( ( $pos ne "" ) && ( $dir ne "" ) ) {
	if ( $pos =~ "^pos" ) {
	    $pos =~ s/pos//;
	    $pos = $places[ $pos ];
	}
	$dir = $groups[ $dir ];
	if ( open( OUT, ">>" . $FILE_TIME ) ) {
	    print OUT $pos . "," . $dir . "," . $data . "\n";
	    close( OUT );
	}
    }
}

###############################################################################
# Read Definition File
###############################################################################
sub ReadDefinition {
    @places = ();
    %placecheck = ();
    %positions = ();
    if ( open( IN, "<" . $FILE_POINT ) ) {
	while( <IN> ) {
	    chop;
	    $_ =~ s/\r//;
	    next  if $_ =~ /^#/;
	    my $point, $pos, $suffix;
	    ( $point, $pos ) = split( ",", $_ );
	    $suffix = "";

	    while( $placecheck{ $point . $suffix } ) {
		$suffix++;
	    }
	    $point = $point . $suffix;
	    $placecheck{ $point } = $point;

	    @places = ( @places, $point );
	    $positions{ $point } = $pos;
	}
	close( IN );
    }

    @groups = ();
    %directions = ();
    if ( open( IN, "<" . $FILE_GROUP ) ) {
	while( <IN> ) {
	    chop;
	    $_ =~ s/\r//;
	    next  if $_ =~ /^#/;
	    my $group, $dir;
	    ( $group, $dir ) = split( ",", $_ );
	    @groups = ( @groups, $group );
	    $directions{ $group } = $dir;
	}
	close( IN );
    }
}

###############################################################################
# Read Data File
###############################################################################
sub ReadDataFile {
    %act_time = ();

    # default pace
    for ( $j = 0; $j <= $#groups; $j++ ) {
	$act_time{ "pace-" . $groups[ $j ] } = &Time2Int( $pace_default );
	$act_time{ $places[ 0 ] . "-" . $groups[ $j ] } = &Time2Int( $start_default );
    }

    if ( open( IN, "<" . $FILE_TIME ) ) {
	while( <IN> ) {
	    chop;
	    $_ =~ s/\r//;
	    next  if $_ =~ /^#/;
	    my $point, $group, $time;
	    ( $point, $group, $time ) = split( ",", $_ );
	    if ( $point eq "note" ) {
		$act_time{ $point . "-" . $group } = $time;
	    } else {
		$act_time{ $point . "-" . $group } = &Time2Int( $time );
	    }
	}
	close( IN );
    }
}

###############################################################################
# \z
###############################################################################
sub CalcEstimTime {
    %est_time = ();
    %act_pace = ();

    my $j;
    for ( $j = 0; $j <= $#groups; $j++ ) {
	my $group = $groups[ $j ];
	my $dir = $directions{ $group };

	my $pace = $act_time{ "pace-" . $group } / 60;
	my $prev_act = -1;

	my $est_tim = 0;
	my $est_pos = 0;
	my $i = ( $dir eq "down" ) ? 0 : $#places;

	while ( ( $dir eq "down" ) ? ( $i <= $#places ) : ( $i >= 0 ) ) {

#	for ( $i = $#places; $i >= 0; $i-- ) {
#	for ( $i = 0; $i <= $#places; $i++ ) {

	    my $point = $places[ $i ];
	    my $act_tim = $act_time{ $point . "-" . $group };
	    if ( $act_tim != 0 ) {

		$est_time{ $point . "-" . $group } = $act_tim;

		$est_tim = $act_tim;
		$est_pos = $positions{ $point };

		if ( $prev_act >= 0 ) {
		    my $diff = abs( $est_pos - $prev_act_pos );
		    $diff = 0.01  if ( $diff < 0.01 );
		    my $act_pac = abs( $est_tim - $prev_act_time ) *60 / $diff;
		    $act_pace{ $point . "-" . $group } = $act_pac;
		}

		$prev_act = $i;
		$prev_act_pos = $est_pos;
		$prev_act_time = $est_tim;
	    } else {
		$est_tim += abs( $est_pos - $positions{ $point } ) * $pace;
		$est_pos = $positions{ $point };

		$est_time{ $point . "-" . $group } = $est_tim;
	    }
	    $i += ( $dir eq "down" ) ? 1 : -1;
	}
    }
}

###############################################################################
# Print f[^
###############################################################################
sub PrintDataTable {

    if ( $LARGEFONT ) {
	print "<font size=\"+2\">\n";
    } else {
	print "<font size=\"+0\">\n";
    }

    print "$VERSION<br>\n";

    print "<form action=\"" . $PROG . "\" method=\"get\">\n";
    print "<input type=\"submit\" value=\"XV\" style=\"font-size:24px\">\n";
    if ( ! $SHOWCALC ) {
	print "<input type=\"checkbox\" name=\"showcalc\" value=\"1\" style=\"width:24px;height:24px\">\n";
	print "y[XvZ";
    }
    print "</form>\n";
    if ( ! $keys{ "refresh" } ) {
#	print "<a href=\"" . $PROG . "?refresh=1\"> XV </a>";
	print "<form action=\"" . $PROG . "?refresh=1\" method=\"get\">\n";
	print "<input type=\"submit\" value=\"XV\" style=\"font-size:24px\">\n";
	print "<input type=\"hidden\" name=\"refresh\" value=\"1\">\n";
    	print "</form>\n";
    }

#################################

    print "<form action=\"" . $PROG . "\" method=\"get\">\n";

    print "<table border=1";
    if ( $LARGEFONT ) {
	print " style=\"font-size:25px;\"";
    }

    print ">";

    print "<tr><td></td><td></td>";
    my @colseq = ();
    my $j;
    for ( $j = 0; $j <= $#groups; $j++ ) {
	@colseq = ( @colseq, $j );
    }
    @colseq = reverse( @colseq )  if ( $REVCOL != 0 );

    foreach $j ( @colseq ) {
#    for ( $j = 0; $j <= $#groups; $j++ ) {
	my $group = $groups[ $j ];
	my $dir = $directions{ $group };
	if ( $show_calc ) {
	    print "<td colspan=3>";
	} else {
	    print "<td>";
	}
	if ( $SIMPLEUI ) {
	    print "<a href=\"" . $PROG . "?mode=simple&group=" . $j . "\">";
	    print $group;
	    print "</a>";
	} else {
	    print $group;
	}
	print "(" . $dir . ")"  if ( $SHOWDIRS );
	print "</td>";
    }
    if ( $USENAME ) {
	print "<td>";
	print "<input type=\"radio\" name=\"position\" value=\"name-add\">";
	if ( $SIMPLEUI ) {
	    print "<a href=\"" . $PROG . "?mode=simpleadd\">";
	    print "ǉ";
	    print "</a>";
	} else {
	    print "ǉ";
	}
	print "</td>";
    }
    print "</tr>\n";



    if ( $USENAME ) {
	print "<tr><td colspan=2>폜</td>";
	foreach $j ( @colseq ) {
	    $group = $groups[ $j ];
	    $dir = $directions{ $group };

	    if ( $show_calc ) {
		print "<td colspan=3 align=center>";
	    } else {
		print "<td align=center>";
	    }
	    print "<input type=\"radio\" name=\"position\" value=\"name-" . $j . "\">";

	}
	print "</tr>\n";
    }





    print "<tr><td></td><td></td>";
    foreach $j ( @colseq ) {
	print "<td></td>";
	if ( $show_calc ) {
	    print "<td>pace</td>";
	    print "<td></td>";
	}
    }
    print "</tr>\n";

    my $i;
    my $first_group = $groups[ 0 ];
    for ( $i = 0; $i <= $#places; $i++ ) {
	my $point = $places[ $i ];
	my $distance = $positions{ $point };
	print "<tr>";
	print "<td>";
	if ( $SIMPLEUI ) {
	    print "<a href=\"" . $PROG . "?mode=simplepoint&place=" . $i . "\">";
	    print $point;
	    print "</a>";
	} else {
	    print $point;
	}
	print "</td>";
	print "<td align=right>" . $distance . " km</td>";

	my $first_est = $est_time{ $point . "-" . $first_group };
	foreach $j ( @colseq ) {
	    $group = $groups[ $j ];
	    $dir = $directions{ $group };

	    print "<td>";
	    print "<input type=\"radio\" name=\"position\" value=\"pos" . $i . "-" . $j ."\">";
	    print &FormatTime( $act_time{ $point . "-" . $group } ) . "</td>";
	    if ( $show_calc ) {
		print "<td>" . &FormatTime( $act_pace{ $point . "-" . $group } ) . "</td>";
		my $group_est = $est_time{ $point . "-" . $group };
		if ( $HLCOLOR && ( $group_est > $first_est ) ) {
			print "<td bgcolor=" . $HIGHLIGHT . ">";
		    } else {
			print "<td>";
		    }
		print &FormatTime( $est_time{ $point . "-" . $group } ) . "</td>";
	    }
	}

	print "</tr>\n";
    }

    print "<tr><td colspan=2>y[X</td>";
    foreach $j ( @colseq ) {
	$group = $groups[ $j ];
	$dir = $directions{ $group };

	if ( $show_calc ) {
	    print "<td colspan=3 align=center>";
	} else {
	    print "<td align=center>";
	}

	print "<input type=\"radio\" name=\"position\" value=\"pace-" . $j . "\">";
	print &FormatTime( $act_time{ "pace-" . $group } ) . "</td>";

    }
    print "</tr>\n";

    if ( $USENOTE ) {
	print "<tr><td colspan=2>Rg</td>";
	foreach $j ( @colseq ) {
	    $group = $groups[ $j ];
	    $dir = $directions{ $group };

	    if ( $show_calc ) {
		print "<td colspan=3 align=center>";
	    } else {
		print "<td align=center>";
	    }

	    print "<input type=\"radio\" name=\"position\" value=\"note-" . $j . "\">";
	    print $act_time{ "note-" . $group } . "</td>";

	}
	print "</tr>\n";
    }

    print "</table>";

# f[^͕
    print "<input type=\"checkbox\" name=\"now\" style=\"width:24px;height:24px\">\n";
    print "ݎgp<br>\n";
    print "<input type=\"text\" name=\"data\">\n";
    print "<input type=\"submit\" value=\"OK\" style=\"font-size:24px\">\n";
    print "</form>\n";

    print "</font>\n";

#################################

    print "<form action=\"" . $PROG . "\" method=\"get\">\n";
    print "<input type=\"submit\" value=\"XV\" style=\"font-size:24px\">\n";
    if ( ! $SHOWCALC ) {
	print "<input type=\"checkbox\" name=\"showcalc\" value=\"1\" style=\"width:24px;height:24px\">\n";
	print "y[XvZ";
    }
    print "</form>\n";

}


###############################################################################
# VvGg[[h
###############################################################################
sub PrintSimpleAddEntry {
    my $pl = $keys{ "place" };
    if ( $pl eq "" ) {
	$pl = 1;
    }
    if ( $pl < 0 ) {
	$pl = 0;
    }
    if ( $pl > $#places ) {
	$pl = $#places;
    }

    print "<font size=\"7\">\n";

    print "<h3>ǉ UI</h3>";

    print "<form action=\"" . $PROG . "\" method=\"get\">\n";

# f[^͕
    print "<table style=\"font-size:32px\">\n";
    print "<tr><td>";
    print "Name: ";
    print "</td><td>";
    print "<input type=\"text\" name=\"data\" style=\"font-size:32px\">\n";
    print "</td><td>";
    print "[bP";
    print "</td></tr>\n";
    print "<tr><td>";
    print "Note: ";
    print "</td><td>";
    print "<input type=\"text\" name=\"data2\" style=\"font-size:32px\">\n";
    print "</td><td>";
    print "̐FȂ";
    print "</td></tr>\n";
    print "<tr><td>";
    print "Pace: ";
    print "</td><td>";
    print "<input type=\"text\" name=\"data3\" style=\"font-size:32px\">\n";
    print "</td><td>";
    print "ɒxȂ";
    print "</td></tr>\n";
    print "</table>\n";

    print "<input type=\"text\" name=\"mode\" value=\"simpleadd\" hidden>\n";
    print "<input type=\"text\" name=\"position\" value=\"name-addnow\" hidden>\n";
    print "<input type=\"text\" name=\"place\" value=\"" . $pl . "\" hidden>\n";

    print "<input type=\"submit\" value=\"OK\" style=\"font-size:32px\">\n";
    print "ݎ";
    print "</form>\n";

    print "<br>";
    print "<a href=\"" . $PROG . "?mode=simpleadd&place=" . ($pl - 1) . "\">";
    print "<h3></h3></a>\n";

    print "<h3>" . $places[ $pl ] . "</h3></a>\n";

    print "<a href=\"" . $PROG . "?mode=simpleadd&place=" . ($pl + 1) . "\">";
    print "<h3></h3></a>\n";
    print "<br>";

    print "<a href=\"" . $PROG . "?mode=simpleadd\">";
    print "<h3>XV</h3></a>\n";
    print "<a href=\"" . $PROG . "\">";
    print "<h3>Ŝ</h3></a>\n";

    print "</font>\n";
}
###############################################################################
sub PrintSimplePointEntry {
    my $pl = $keys{ "place" };

    print "<font size=\"7\">\n";

    print "<H2>" . $places[ $pl ] . "</H2></a>\n";


    my @colseq = ();
    my $j;
    for ( $j = 0; $j <= $#groups; $j++ ) {
	@colseq = ( @colseq, $j );
    }
    @colseq = reverse( @colseq )  if ( $REVCOL != 0 );

    print "<form action=\"" . $PROG . "\" method=\"get\">\n";

    print "<input type=\"submit\" value=\"OK\" style=\"font-size:32px\">\n";
    print "ݎ";

    print "<table border=1 style=\"font-size:48px\">";
    print "<tr><td>Name</td><td>Time</td><td>Note</td></tr>\n";
    foreach $j ( @colseq ) {
	my $group = $groups[ $j ];
	my $point = $places[ $pl ];
	print "<tr>";
	print "<td>";
	print "<input type=\"radio\" name=\"position\" value=\"pos" . $pl . "-" . $j ."\" style=\"width:32px;height:32px\">";
	print $group;
	print "</td><td>";
	print &FormatTime( $act_time{ $point . "-" . $group } );
	print "</td><td>";
	print $act_time{ "note-" . $group };
	print "</td>";
	print "</tr>\n";
    }
    print "</table>";

    print "<input type=\"text\" name=\"mode\" value=\"simplepoint\" hidden>\n";
    print "<input type=\"text\" name=\"place\" value=\"" . $pl . "\" hidden>\n";
    print "<input type=\"text\" name=\"now\" value=\"on\" hidden>\n";

    print "</form>\n";


    print "<a href=\"" . $PROG . "?mode=simplepoint&place=" . $pl . "\">";
    print "<h3>XV</h3></a>\n";
    print "<a href=\"" . $PROG . "\">";
    print "<h3>Ŝ</h3></a>\n";

    print "</font>\n";
}

###############################################################################
sub PrintSimpleEntry {
#    my $pl = $keys{ "place" };
    my $gr = $keys{ "group" };
    my $offset = $keys{ "offset" };

    # O[v
    my $group = $groups[ $gr ];
    my $dir = $directions{ $group };

    my $num_point = $#places;

    # ŏI͂
    my $pl;
    if ( $dir eq "up" ) {
	$pl = $num_point;
	for ( my $i = $num_point; $i >= 0; $i-- ) {
	    my $po = $places[ $i ];
	    if ( $act_time{ $po . "-" . $group } != 0 ) {
		$pl = $i;
	    }
	}
	$pl--;
    } else {
	$pl = -1;
	for ( my $i = 0; $i <= $num_point; $i++ ) {
	    my $po = $places[ $i ];
	    if ( $act_time{ $po . "-" . $group } != 0 ) {
		$pl = $i;
	    }
	}
	$pl++;
    }
    $pl += $offset;
    if ( $pl < 0 ) {
	$pl = 0;
	$offset++;
    }
    if ( $pl > $num_point ) {
	$pl = $num_point;
	$offset--;
    }

    # ꏊ
    my $point = $places[ $pl ];
    my $distance = $positions{ $point };

    print "<font size=\"7\">\n";

    print "<H2>$group</H2>\n";
    print "<H2>$point ($distance km)</H2>\n";
    print "<H3>" . &FormatTime( $act_time{ $point . "-" . $group } ) . "</H3>\n";
    print "<br>\n";
    print "<a href=\"" . $PROG . "?mode=simple&group=" . $gr . "&now=on&position=pos" . $pl . "-" . $gr . "\">";
    print "<H2>ݎ</H2></a>\n";

    print "<br>\n";
    print "<a href=\"" . $PROG . "?mode=simple&group=" . $gr . "&offset=" . ($offset - 1) . "\">";
    print "<h3> O</h3></a>\n";
    print "<a href=\"" . $PROG . "?mode=simple&group=" . $gr . "&offset=" . ($offset + 1) . "\">";
    print "<h3> </h3></a>\n";

    print "<br>";
    print "<a href=\"" . $PROG . "?mode=simple&group=" . $gr . "\">";
    print "<h3>XV</h3></a>\n";
    print "<a href=\"" . $PROG . "\">";
    print "<h3>Ŝ</h3></a>\n";

    print "</font>\n";
}


###############################################################################
# CuA̕\
###############################################################################
sub FormatTime {
    if ( $_[0] != 0 ) {
	my $hour = int( $_[0] / 60 );
	my $minute = int( $_[0] % 60 );

	my $min10 = int( $minute / 10 );
	my $min1 = int( $minute % 10 );

	$hour . ":" . $min10 . $min1;
    } else {
	"";
    }
}

sub Time2Int {
    my $hour, $minute;
    ( $hour, $minute ) = split( ":", $_[0] );

    $hour * 60 + $minute;
}
